Index: /trunk/sources/HeuristicLab.MainForm.WindowsForms/3.3/ViewHost.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm.WindowsForms/3.3/ViewHost.cs	(revision 3437)
+++ /trunk/sources/HeuristicLab.MainForm.WindowsForms/3.3/ViewHost.cs	(revision 3437)
@@ -0,0 +1,282 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Windows.Forms;
+using HeuristicLab.MainForm;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.MainForm.WindowsForms {
+  [Content(typeof(object))]
+  public sealed partial class ViewHost : AsynchronousContentView {
+    public ViewHost() {
+      InitializeComponent();
+      cachedViews = new Dictionary<Type, IContentView>();
+      viewType = null;
+      Content = null;
+      startDragAndDrop = false;
+      viewContextMenuStrip.IgnoredViewTypes = new List<Type>() { typeof(ViewHost) };
+      activeView = null;
+    }
+    public ViewHost(IContent content)
+      : this() {
+      this.Content = content;
+    }
+
+    public ViewHost(IContentView contentView)
+      : this() {
+      this.viewType = contentView.GetType();
+      this.Content = contentView.Content;
+      this.cachedViews.Add(contentView.GetType(), contentView);
+      this.activeView = contentView;
+      this.RegisterActiveViewEvents();
+      this.OnViewTypeChanged();
+      this.ActiveViewChanged();
+    }
+
+    private Dictionary<Type, IContentView> cachedViews;
+    public IEnumerable<IContentView> Views {
+      get { return cachedViews.Values; }
+    }
+
+    private IContentView activeView;
+    public IContentView ActiveView {
+      get { return this.activeView; }
+      private set {
+        if (activeView != value) {
+          if (activeView != null) {
+            DeregisterActiveViewEvents();
+            View view = activeView as View;
+            if (view != null)
+              view.OnHidden(EventArgs.Empty);
+          }
+          activeView = value;
+          if (activeView != null) {
+            RegisterActiveViewEvents();
+            View view = activeView as View;
+            if (view != null)
+              view.OnShown(new ViewShownEventArgs(view, false));
+          }
+          ActiveViewChanged();
+          OnViewTypeChanged();
+        }
+      }
+    }
+    private Type viewType;
+    public Type ViewType {
+      get { return this.viewType; }
+      set {
+        if (viewType != value) {
+          if (value != null && !ViewCanShowContent(value, Content))
+            throw new ArgumentException(string.Format("View \"{0}\" cannot display content \"{1}\".",
+                                                      value, Content.GetType()));
+          viewType = value;
+          OnViewTypeChanged();
+        }
+      }
+    }
+    public new IContent Content {
+      get { return base.Content; }
+      set {
+        if (value == null || this.Content == null || value.GetType() != this.Content.GetType())
+          cachedViews.Clear();
+        viewContextMenuStrip.Item = value;
+        this.viewsLabel.Enabled = value != null;
+        base.Content = value;
+      }
+    }
+
+    public new bool Enabled {
+      get { return base.Enabled; }
+      set {
+        this.SuspendRepaint();
+        base.Enabled = value;
+        this.viewsLabel.Enabled = value;
+        this.ResumeRepaint(true);
+      }
+    }
+
+
+
+    protected override void OnContentChanged() {
+      messageLabel.Visible = false;
+      viewsLabel.Visible = false;
+      viewPanel.Visible = false;
+
+      if (Content != null) {
+        if (viewContextMenuStrip.Items.Count == 0)
+          messageLabel.Visible = true;
+        else
+          viewsLabel.Visible = true;
+
+        if (!ViewCanShowContent(viewType, Content)) {
+          ViewType = MainFormManager.GetDefaultViewType(Content.GetType());
+          if ((viewType == null) && (viewContextMenuStrip.Items.Count > 0))  // create first available view if default view is not available
+            ViewType = (Type)viewContextMenuStrip.Items[0].Tag;
+        }
+
+        foreach (IContentView view in cachedViews.Values)
+          view.Content = this.Content;
+      } else {
+        if (viewPanel.Controls.Count > 0) viewPanel.Controls[0].Dispose();
+        viewPanel.Controls.Clear();
+        cachedViews.Clear();
+      }
+    }
+
+
+    private void OnViewTypeChanged() {
+      viewPanel.Controls.Clear();
+      if (viewType == null || Content == null)
+        return;
+      if (!ViewCanShowContent(viewType, Content))
+        throw new InvalidOperationException(string.Format("View \"{0}\" cannot display content \"{1}\".",
+                                                          viewType, Content.GetType()));
+
+      UpdateActiveMenuItem();
+      IContentView view;
+      if (cachedViews.ContainsKey(ViewType))
+        view = cachedViews[ViewType];
+      else {
+        view = MainFormManager.CreateView(viewType, Content);
+        view.ReadOnly = this.ReadOnly;
+        view.Locked = this.Locked;
+        cachedViews.Add(viewType, view);
+      }
+      this.ActiveView = view;
+
+      Control control = (Control)view;
+      control.Dock = DockStyle.Fill;
+      viewPanel.Controls.Add(control);
+      viewPanel.Visible = true;
+    }
+
+
+
+    private void RegisterActiveViewEvents() {
+      activeView.Changed += new EventHandler(activeView_Changed);
+      activeView.CaptionChanged += new EventHandler(activeView_CaptionChanged);
+    }
+    private void DeregisterActiveViewEvents() {
+      activeView.Changed -= new EventHandler(activeView_Changed);
+      activeView.CaptionChanged -= new EventHandler(activeView_CaptionChanged);
+    }
+    private void activeView_CaptionChanged(object sender, EventArgs e) {
+      this.ActiveViewChanged();
+    }
+    private void activeView_Changed(object sender, EventArgs e) {
+      this.ActiveViewChanged();
+    }
+    private void ActiveViewChanged() {
+      if (ActiveView != null) {
+        this.Caption = this.ActiveView.Caption;
+        this.Locked = this.ActiveView.Locked;
+      }
+    }
+
+    #region forwarding of view events
+    protected override void OnReadOnlyChanged() {
+      base.OnReadOnlyChanged();
+      foreach (IContentView view in cachedViews.Values)
+        view.ReadOnly = this.ReadOnly;
+    }
+    protected override void OnLockedChanged() {
+      base.OnLockedChanged();
+      foreach (IContentView view in cachedViews.Values)
+        view.Locked = this.Locked;
+    }
+    internal protected override void OnShown(ViewShownEventArgs e) {
+      base.OnShown(e);
+      View view = this.ActiveView as View;
+      if (view != null)
+        view.OnShown(e);
+    }
+    internal protected override void OnHidden(EventArgs e) {
+      base.OnHidden(e);
+      View view = this.ActiveView as View;
+      if (view != null)
+        view.OnHidden(e);
+    }
+    internal protected override void OnClosing(FormClosingEventArgs e) {
+      base.OnClosing(e);
+      foreach (View view in this.Views.OfType<View>())
+        view.OnClosing(e);
+    }
+    internal protected override void OnClosed(FormClosedEventArgs e) {
+      base.OnClosed(e);
+      foreach (View view in this.Views.OfType<View>())
+        view.OnClosed(e);
+    }
+    #endregion
+
+    #region GUI actions
+    private void UpdateActiveMenuItem() {
+      foreach (KeyValuePair<Type, ToolStripMenuItem> item in viewContextMenuStrip.MenuItems) {
+        if (item.Key == viewType) {
+          item.Value.Checked = true;
+          item.Value.Enabled = false;
+        } else {
+          item.Value.Checked = false;
+          item.Value.Enabled = true;
+        }
+      }
+    }
+
+    private bool ViewCanShowContent(Type viewType, object content) {
+      if (content == null) // every view can display null
+        return true;
+      if (viewType == null)
+        return false;
+      return ContentAttribute.CanViewType(viewType, Content.GetType()) && viewContextMenuStrip.MenuItems.Any(item => item.Key == viewType);
+    }
+
+    private void viewsLabel_DoubleClick(object sender, EventArgs e) {
+      IContentView view = MainFormManager.CreateView(viewType, Content);
+      view.ReadOnly = this.ReadOnly;
+      view.Locked = this.Locked;
+      view.Show();
+    }
+    private void viewContextMenuStrip_ItemClicked(object sender, ToolStripItemClickedEventArgs e) {
+      Type viewType = (Type)e.ClickedItem.Tag;
+      ViewType = viewType;
+    }
+
+    private bool startDragAndDrop;
+    private void viewsLabel_MouseDown(object sender, MouseEventArgs e) {
+      if (!Locked) {
+        startDragAndDrop = true;
+        viewsLabel.Capture = false;
+      }
+    }
+    private void viewsLabel_MouseLeave(object sender, EventArgs e) {
+      if ((Control.MouseButtons & MouseButtons.Left) == MouseButtons.Left && startDragAndDrop) {
+        DataObject data = new DataObject();
+        data.SetData("Type", Content.GetType());
+        data.SetData("Value", Content);
+        DoDragDrop(data, DragDropEffects.Copy | DragDropEffects.Link);
+      } else
+        startDragAndDrop = false;
+    }
+    #endregion
+  }
+}
Index: /trunk/sources/HeuristicLab.MainForm/3.2/HeuristicLab.MainForm-3.2.csproj
===================================================================
--- /trunk/sources/HeuristicLab.MainForm/3.2/HeuristicLab.MainForm-3.2.csproj	(revision 3436)
+++ /trunk/sources/HeuristicLab.MainForm/3.2/HeuristicLab.MainForm-3.2.csproj	(revision 3437)
@@ -110,7 +110,7 @@
   </ItemGroup>
   <ItemGroup>
-    <ProjectReference Include="..\..\HeuristicLab.Common\3.3\HeuristicLab.Common-3.3.csproj">
-      <Project>{A9AD58B9-3EF9-4CC1-97E5-8D909039FF5C}</Project>
-      <Name>HeuristicLab.Common-3.3</Name>
+    <ProjectReference Include="..\..\HeuristicLab.Common\3.2\HeuristicLab.Common-3.2.csproj">
+      <Project>{1FC004FC-59AF-4249-B1B6-FF25873A20E4}</Project>
+      <Name>HeuristicLab.Common-3.2</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
Index: /trunk/sources/HeuristicLab.MainForm/3.2/HeuristicLabMainFormPlugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.MainForm/3.2/HeuristicLabMainFormPlugin.cs.frame	(revision 3436)
+++ /trunk/sources/HeuristicLab.MainForm/3.2/HeuristicLabMainFormPlugin.cs.frame	(revision 3437)
@@ -28,4 +28,5 @@
   [Plugin("HeuristicLab.MainForm", "3.2.0.$WCREV$")]
   [PluginFile("HeuristicLab.MainForm-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Common", "3.2")]
   public class HeuristicLabMainFormPlugin : PluginBase {
   }
Index: /trunk/sources/HeuristicLab.MainForm/3.3/ActionUserInterfaceItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm/3.3/ActionUserInterfaceItem.cs	(revision 3437)
+++ /trunk/sources/HeuristicLab.MainForm/3.3/ActionUserInterfaceItem.cs	(revision 3437)
@@ -0,0 +1,66 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.MainForm {
+  public abstract class ActionUserInterfaceItem : PositionableUserInterfaceItem, IActionUserInterfaceItem {
+    protected ActionUserInterfaceItem() {
+      MainFormManager.MainForm.ActiveViewChanged += this.OnActiveViewChanged;
+      MainFormManager.MainForm.Changed += this.OnMainFormChanged;
+      MainFormManager.MainForm.ViewShown += this.OnViewShown;
+      MainFormManager.MainForm.ViewClosed += this.OnViewClosed;
+    }
+
+    public abstract string Name { get; }
+
+    public virtual System.Drawing.Image Image {
+      get { return null; }
+    }
+
+    public virtual string ToolTipText {
+      get { return string.Empty; }
+    }
+
+    public abstract void Execute();
+
+    protected virtual void OnActiveViewChanged(object sender, EventArgs e) {
+    }
+
+    protected virtual void OnMainFormChanged(object sender, EventArgs e) {
+    }
+
+    protected virtual void OnViewChanged(object sender, EventArgs e) {
+    }
+
+    private void OnViewShown(object sender, ViewShownEventArgs e) {
+      if (e.FirstTimeShown)
+        e.View.Changed += this.OnViewChanged;
+    }
+
+    private void OnViewClosed(object sender, ViewEventArgs e) {
+      e.View.Changed -= this.OnViewChanged;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.MainForm/3.3/ContentAttribute.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm/3.3/ContentAttribute.cs	(revision 3437)
+++ /trunk/sources/HeuristicLab.MainForm/3.3/ContentAttribute.cs	(revision 3437)
@@ -0,0 +1,74 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Reflection;
+
+namespace HeuristicLab.MainForm {
+  [AttributeUsage(AttributeTargets.Class, AllowMultiple = true, Inherited = false)]
+  public sealed class ContentAttribute : Attribute {
+    public ContentAttribute(Type contentType) {
+      this.contentType = contentType;
+    }
+
+    public ContentAttribute(Type contentType, bool isDefaultView)
+      : this(contentType) {
+      this.isDefaultView = isDefaultView;
+    }
+
+    private bool isDefaultView;
+    public bool IsDefaultView {
+      get { return this.isDefaultView; }
+      set { this.isDefaultView = value; }
+    }
+
+    private Type contentType;
+    public Type ContentType {
+      get { return this.contentType; }
+    }
+
+    public static bool HasContentAttribute(MemberInfo viewType) {
+      ContentAttribute[] attributes = (ContentAttribute[])viewType.GetCustomAttributes(typeof(ContentAttribute), false);
+      return attributes.Length != 0;
+    }
+
+    public static bool CanViewType(MemberInfo viewType, Type content) {
+      ContentAttribute[] attributes = (ContentAttribute[])viewType.GetCustomAttributes(typeof(ContentAttribute), false);
+      return attributes.Any(a => content.IsAssignableTo(a.contentType));
+    }
+
+    internal static IEnumerable<Type> GetDefaultViewableTypes(Type viewType) {
+      ContentAttribute[] attributes = (ContentAttribute[])viewType.GetCustomAttributes(typeof(ContentAttribute), false);
+      return from a in attributes
+             where a.isDefaultView
+             select a.contentType;
+    }
+
+    internal static IEnumerable<Type> GetViewableTypes(Type viewType) {
+      ContentAttribute[] attributes = (ContentAttribute[])viewType.GetCustomAttributes(typeof(ContentAttribute), false);
+      return from a in attributes
+             select a.contentType;
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.MainForm/3.3/HeuristicLab.MainForm-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.MainForm/3.3/HeuristicLab.MainForm-3.3.csproj	(revision 3437)
+++ /trunk/sources/HeuristicLab.MainForm/3.3/HeuristicLab.MainForm-3.3.csproj	(revision 3437)
@@ -0,0 +1,142 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="3.5" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProductVersion>9.0.30729</ProductVersion>
+    <SchemaVersion>2.0</SchemaVersion>
+    <ProjectGuid>{3BD61258-31DA-4B09-89C0-4F71FEF5F05A}</ProjectGuid>
+    <OutputType>Library</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>HeuristicLab.MainForm</RootNamespace>
+    <AssemblyName>HeuristicLab.MainForm-3.3</AssemblyName>
+    <TargetFrameworkVersion>v3.5</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <SignAssembly>true</SignAssembly>
+    <AssemblyOriginatorKeyFile>HeuristicLab.snk</AssemblyOriginatorKeyFile>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>bin\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+    <DocumentationFile>bin\Release\HeuristicLab.MainForm-3.3.xml</DocumentationFile>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x64' ">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x64\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x64' ">
+    <OutputPath>bin\x64\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x64</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <DocumentationFile>bin\x64\Release\HeuristicLab.MainForm-3.3.xml</DocumentationFile>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|x86' ">
+    <DebugSymbols>true</DebugSymbols>
+    <OutputPath>bin\x86\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <DebugType>full</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|x86' ">
+    <OutputPath>bin\x86\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <Optimize>true</Optimize>
+    <DebugType>pdbonly</DebugType>
+    <PlatformTarget>x86</PlatformTarget>
+    <ErrorReport>prompt</ErrorReport>
+    <DocumentationFile>bin\x86\Release\HeuristicLab.MainForm-3.3.xml</DocumentationFile>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="System" />
+    <Reference Include="System.Core">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.Drawing" />
+    <Reference Include="System.Xml.Linq">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.Data.DataSetExtensions">
+      <RequiredTargetFramework>3.5</RequiredTargetFramework>
+    </Reference>
+    <Reference Include="System.Data" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="HeuristicLabMainFormPlugin.cs.frame" />
+    <Compile Include="Interfaces\IStorableContentView.cs" />
+    <Compile Include="ViewAttribute.cs" />
+    <Compile Include="Interfaces\IContentView.cs" />
+    <Compile Include="Interfaces\IActionUserInterfaceItem.cs" />
+    <Compile Include="Interfaces\IPositionableUserInterfaceItem.cs" />
+    <Compile Include="PositionableUserInterfaceItem.cs" />
+    <Compile Include="TypeExtension.cs" />
+    <Compile Include="ViewShownEventArgs.cs" />
+    <Compile Include="ViewEventArgs.cs" />
+    <Compile Include="ToolBarSeparatorItem.cs" />
+    <Compile Include="Interfaces\IToolBarSeparatorItem.cs" />
+    <Compile Include="Interfaces\IMenuItem.cs" />
+    <Compile Include="Interfaces\IMenuSeparatorItem.cs" />
+    <Compile Include="Interfaces\IToolBarItem.cs" />
+    <Compile Include="MainFormManager.cs" />
+    <Compile Include="MenuSeparatorItem.cs" />
+    <Compile Include="HeuristicLabMainFormPlugin.cs" />
+    <Compile Include="Interfaces\IMainForm.cs" />
+    <Compile Include="Interfaces\IUserInterfaceItem.cs" />
+    <Compile Include="Interfaces\IView.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="ActionUserInterfaceItem.cs" />
+    <Compile Include="ContentAttribute.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Common\3.3\HeuristicLab.Common-3.3.csproj">
+      <Project>{A9AD58B9-3EF9-4CC1-97E5-8D909039FF5C}</Project>
+      <Name>HeuristicLab.Common-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
+      <Project>{94186A6A-5176-4402-AE83-886557B53CCA}</Project>
+      <Name>HeuristicLab.PluginInfrastructure</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="HeuristicLab.snk" />
+    <None Include="Properties\AssemblyInfo.frame" />
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+  <PropertyGroup>
+    <PreBuildEvent>set Path=%25Path%25;$(ProjectDir);$(SolutionDir)
+set ProjectDir=$(ProjectDir)
+set SolutionDir=$(SolutionDir)
+set Outdir=$(Outdir)
+
+call PreBuildEvent.cmd
+SubWCRev "%25ProjectDir%25\" "%25ProjectDir%25\HeuristicLabMainFormPlugin.cs.frame" "%25ProjectDir%25\HeuristicLabMainFormPlugin.cs"</PreBuildEvent>
+  </PropertyGroup>
+</Project>
Index: /trunk/sources/HeuristicLab.MainForm/3.3/HeuristicLabMainFormPlugin.cs.frame
===================================================================
--- /trunk/sources/HeuristicLab.MainForm/3.3/HeuristicLabMainFormPlugin.cs.frame	(revision 3437)
+++ /trunk/sources/HeuristicLab.MainForm/3.3/HeuristicLabMainFormPlugin.cs.frame	(revision 3437)
@@ -0,0 +1,33 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.Modeling.Database {
+  [Plugin("HeuristicLab.MainForm", "3.3.0.$WCREV$")]
+  [PluginFile("HeuristicLab.MainForm-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Common", "3.3")]
+  public class HeuristicLabMainFormPlugin : PluginBase {
+  }
+}
Index: /trunk/sources/HeuristicLab.MainForm/3.3/Interfaces/IActionUserInterfaceItem.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm/3.3/Interfaces/IActionUserInterfaceItem.cs	(revision 3437)
+++ /trunk/sources/HeuristicLab.MainForm/3.3/Interfaces/IActionUserInterfaceItem.cs	(revision 3437)
@@ -0,0 +1,37 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Drawing;
+
+namespace HeuristicLab.MainForm {
+  public interface IActionUserInterfaceItem : IPositionableUserInterfaceItem {
+    string Name { get; }
+
+    Image Image { get; }
+    string ToolTipText { get; }
+
+    void Execute();
+  }
+}
Index: /trunk/sources/HeuristicLab.MainForm/3.3/Interfaces/IContentView.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm/3.3/Interfaces/IContentView.cs	(revision 3437)
+++ /trunk/sources/HeuristicLab.MainForm/3.3/Interfaces/IContentView.cs	(revision 3437)
@@ -0,0 +1,34 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using System.ComponentModel;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.MainForm {
+  public interface IContentView : IView {
+    IContent Content { get; set; }
+    bool Locked { get; set; }
+    event EventHandler LockedChanged;
+  }
+}
Index: /trunk/sources/HeuristicLab.MainForm/3.3/Interfaces/IMainForm.cs
===================================================================
--- /trunk/sources/HeuristicLab.MainForm/3.3/Interfaces/IMainForm.cs	(revision 3437)
+++ /trunk/sources/HeuristicLab.MainForm/3.3/Interfaces/IMainForm.cs	(revision 3437)
@@ -0,0 +1,47 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Drawing;
+using System.ComponentModel;
+
+namespace HeuristicLab.MainForm {
+  public interface IMainForm {
+    string Title { get; set; }
+
+    IView ActiveView { get; }
+    IEnumerable<IView> Views { get; }
+
+    event EventHandler ActiveViewChanged;
+    event EventHandler Changed;
+
+    event EventHandler<ViewEventArgs> ViewClosed;
+    event EventHandler<ViewShownEventArgs> ViewShown;
+    event EventHandler<ViewEventArgs> ViewHidden;
+
+    Type UserInterfaceItemType { get; }
+    void CloseAllViews();
+    void Close();
+  }
+}
